<template>
    <v-navigation-drawer v-model="store.value.drawer" :clipped="$vuetify.breakpoint.lgAndUp" app>
        <v-list dense>
            <template v-for="item in items">
                <v-list-group v-if="item.children" :key="item.text" v-model="item.model"
                              :prepend-icon="item.model ? item.icon : item['icon-alt']" append-icon="">
                    <template v-slot:activator>
                        <v-list-item-content>
                            <v-list-item-title>
                                {{ item.text }}
                            </v-list-item-title>
                        </v-list-item-content>
                    </template>
                    <v-list-item v-for="(child, i) in item.children" :key="i"
                                 :to="child.route ? child.route : undefined" link>
                        <v-list-item-action v-if="child.icon">
                            <v-icon>{{ child.icon }}</v-icon>
                        </v-list-item-action>
                        <v-list-item-content>
                            <v-list-item-title>
                                {{ child.text }}
                            </v-list-item-title>
                        </v-list-item-content>
                    </v-list-item>
                </v-list-group>

                <v-list-item :key="item.text" :to="item.route ? item.route : undefined" link
                             v-else-if="item.show == null ? true : item.show()"
                             @click.native="item.act ? item.act(): (()=>{})()">
                    <v-list-item-action>
                        <v-icon>{{ item.icon }}</v-icon>
                    </v-list-item-action>
                    <v-list-item-content>
                        <v-list-item-title>
                            {{ item.text }}
                        </v-list-item-title>
                    </v-list-item-content>
                </v-list-item>

            </template>
        </v-list>
    </v-navigation-drawer>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {auth, isPWA} from "../init";
    import {BStorage} from "../../../classLibrary/Storage";
    import {box} from "../index";

    const props = {
        store: BStorage
    };

    const Base = Vue.extend({props});

    @Component({props})
    export default class NavBar extends Base {

        items: any[] = [
            {icon: '$vuetify.icons.dashboard', text: 'Dashboard', route: "/"},
            {icon: '$vuetify.icons.floor', text: 'Floors', route: "/floor"},
            {icon: '$vuetify.icons.subcontractor', text: 'Subcontractor', route: "/sub"},
            {icon: '$vuetify.icons.worker', text: 'Workers', route: "/worker" },
            {icon: '$vuetify.icons.analytics', text: 'Analytics', route: '/analytics'},
            {icon: '$vuetify.icons.warn', text: 'Alerts', route: '/alert'},
            {
                icon: 'mdi-chevron-up',
                'icon-alt': 'mdi-chevron-down',
                text: 'Alert Rules',
                model: false,
                children: [
                    {icon: '$vuetify.icons.trigger', text: 'Triggers', route: '/trigger'},
                    {icon: '$vuetify.icons.action', text: 'Actions', route: '/action'},
                    {icon: '$vuetify.icons.rules', text: 'Rules', route: '/rule'},
                ]
            },
            {icon: '$vuetify.icons.logout', text: 'Logout', act: this.Logout},
            {icon: '$vuetify.icons.add', text: 'Install', act: this.Install, show: this.CheckPWA}
        ];


        CheckPWA(): boolean {
            return !isPWA();
        }


        Install() {
            box.prompt();
        }

        Logout() {
            auth.logOut();
            this.$router.push("/auth");
        }
    }
</script>
